Binarizer (ZXing 3.4.0 API)

com.google.zxing

## Class Binarizer

- java.lang.Object
- - com.google.zxing.Binarizer

- Direct Known Subclasses:
    GlobalHistogramBinarizer

      public abstract class Binarizer
      extends Object

  This class hierarchy provides a set of methods to convert luminance data to 1 bit data. It allows the algorithm to vary polymorphically, for example allowing a very expensive thresholding technique for servers and a fast one for mobile. It also permits the implementation to vary, e.g. a JNI version for Android and a Java fallback version for other platforms.
  Author:
    dswitkin@google.com (Daniel Switkin)

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `Binarizer(LuminanceSource source)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract Binarizer` | `createBinarizer(LuminanceSource source)` Creates a new object with the same type as this Binarizer implementation, but with pristine state.
    `abstract BitMatrix` | `getBlackMatrix()` Converts a 2D array of luminance data to 1 bit data.
    `abstract BitArray` | `getBlackRow(int y, BitArray row)` Converts one row of luminance data to 1 bit data.
    `int` | `getHeight()`
    `LuminanceSource` | `getLuminanceSource()`
    `int` | `getWidth()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Binarizer

          protected Binarizer(LuminanceSource source)

  - ### Method Detail

    - #### getLuminanceSource

          public final LuminanceSource getLuminanceSource()

    - #### getBlackRow

          public abstract BitArray getBlackRow(int y,
                                               BitArray row)
                                        throws NotFoundException

      Converts one row of luminance data to 1 bit data. May actually do the conversion, or return cached data. Callers should assume this method is expensive and call it as seldom as possible. This method is intended for decoding 1D barcodes and may choose to apply sharpening. For callers which only examine one row of pixels at a time, the same BitArray should be reused and passed in with each call for performance. However it is legal to keep more than one row at a time if needed.
      Parameters:
        `y` - The row to fetch, which must be in [0, bitmap height)
        `row` - An optional preallocated array. If null or too small, it will be ignored. If used, the Binarizer will call BitArray.clear(). Always use the returned object.
      Returns:
        The array of bits for this row (true means black).
      Throws:
        `NotFoundException` - if row can't be binarized

    - #### getBlackMatrix

          public abstract BitMatrix getBlackMatrix()
                                            throws NotFoundException

      Converts a 2D array of luminance data to 1 bit data. As above, assume this method is expensive and do not call it repeatedly. This method is intended for decoding 2D barcodes and may or may not apply sharpening. Therefore, a row from this matrix may not be identical to one fetched using getBlackRow(), so don't mix and match between them.
      Returns:
        The 2D array of bits for the image (true means black).
      Throws:
        `NotFoundException` - if image can't be binarized to make a matrix

    - #### createBinarizer

          public abstract Binarizer createBinarizer(LuminanceSource source)

      Creates a new object with the same type as this Binarizer implementation, but with pristine state. This is needed because Binarizer implementations may be stateful, e.g. keeping a cache of 1 bit data. See Effective Java for why we can't use Java's clone() method.
      Parameters:
        `source` - The LuminanceSource this Binarizer will operate on.
      Returns:
        A new concrete Binarizer implementation object.

    - #### getWidth

          public final int getWidth()

    - #### getHeight

          public final int getHeight()

Copyright © 2007–2019. All rights reserved.